
@Grab(group='org.codehaus.groovy', module='groovy-xmlrpc', version='0.8')

import groovy.net.xmlrpc.*

class EggDriveRun
{
	def eggPlantHost
    def suite_path
	def script_statements

	def debug = 'true'

    def _debug(str)
    {
		if (this.debug == 'true') {
			println str;
		}
	}

	def runXMLRPC()
	{
		def server = new XMLRPCServerProxy("http://" + this.eggPlantHost)

		// Close an existing session
		try{
			server.EndSession("")
		} catch(e)
		{}
		try
        {
	        println server.StartSession(this.suite_path)
	
	        this.script_statements.readLines().each()
	        {
				println server.execute(it)
	        }
	        println server.EndSession("")
		}
        catch (e)
        {
            println e.toString()
			//System.err.println e.toString() also goes into UC Log not the Error log 
            return 1
        }
		return 0
	}

	def start(args)
	{
		def props = new Properties();
		def inputPropsFile = new File(args[0])
	    try
	    {
            def inputPropsStream = new FileInputStream(inputPropsFile)
            props.load(inputPropsStream);
        }
        catch (IOException e)
		{
		    throw new RuntimeException(e)
		}
        this.eggPlantHost = props['eggDriveHost'] + ':' + props['eggDrivePort']
        this.suite_path = props['suite_path']
		this.script_statements = props['script_statements']

		return runXMLRPC();
	}

}

run = new EggDriveRun();
def res = run.start(args)
System.exit(res)
