

class EggPlantRun
{
	def eggPlanDir
    def runscript_cmd = ""
	def arguments = ""

	def debug = 'false'
	def OSType = "unix"

    def _debug(str)
    {
		if (this.debug == 'true') {
			println str;
		}
	}

	def runScript()
	{
		def cmd = this.runscript_cmd
		if (this.arguments.empty == false)
            cmd = cmd + " " + this.arguments.replace("\n", " ")
		println cmd
		def proc = cmd.execute()
		proc.waitFor() // Wait for the command to finish

		// Obtain status and output
		println "return code: ${ proc.exitValue()}"
		println "stderr: ${proc.err.text}"
		println "stdout: ${proc.in.text}" // *out* from the external program is *in* for groovy
		return proc.exitValue()
	}

	def checkRunscriptPath()
	{
		_debug("os=" + System.properties['os.name'])
		if (System.properties['os.name'].toString().toLowerCase().contains('windows'))
		{
			OSType = "windows"
			def progfiles
			def env = System.getenv()
			if (env.containsKey('ProgramFiles(x86)'))
			{
				progfiles = env['ProgramFiles(x86)']
			}
			else if (env.containsKey('ProgramFiles'))
			{
					progfiles = env['ProgramFiles']
			}
			else
			{
				println "Failed to find the Program Files folder"
				return 4
			}
			def folder = new File(progfiles + "\\eggPlant")
			_debug("path=" + folder.getPath())
			if (folder.exists() == false)
			{
				println "Failed to find the eggPlant install folder: " + folder.getPath()
				return 1
			}
			def runscript = new File(folder.getPath() + "\\runscript.bat")
			if (runscript.exists() == false)
			{
				println "Failed to find runscript.bat in the eggPlant install folder: " + folder.getPath()
				return 2
			}
			this.runscript_cmd = runscript.getAbsolutePath()
		}
		else
		{
			def runscript = new File( this.eggPlanDir + "/runscript")
			if (runscript.exists() == false)
			{
				println "Failed to find runscript: " + runscript.getPath()
				return 2
			}
			this.runscript_cmd = runscript.getAbsolutePath()
		}

		return 0
	}


	def start(args)
	{
		def props = new Properties();
		def inputPropsFile = new File(args[0])
	    try
	    {
            def inputPropsStream = new FileInputStream(inputPropsFile)
            props.load(inputPropsStream);
        }
        catch (IOException e)
		{
		    throw new RuntimeException(e)
		}
        this.eggPlanDir = props['eggPlant_path']
		this.arguments = props['arguments']

		def result = checkRunscriptPath()
		if (result != 0)
			return result

		return runScript();
	}

}

run = new EggPlantRun();
def res = run.start(args)
System.exit(res)
